import React from "react";
import { FIELD_SCHEMA_SYMBOL } from "../constants";
import type { ArrayShift, FormSchema, FormSchemaBase, FieldSchemaBase, FormSchemaSymbol, FormValuePrimitive, ConvertFieldToFormPrimitiveValue } from "./types";
export declare function useLocalStore<T extends Record<string, any>>(base: T): import("./types").StoreSchema<T>;
export declare function useFormix<T extends FormSchemaBase, U extends FormSchema<T>[FormSchemaSymbol], F extends U["fields"], G extends U["groups"], NF extends keyof F, NG extends keyof G>(schema: T | FormSchema<T>): {
    $: <N extends NF>(name: N) => {
        bind: (options?: Partial<{
            ref: React.ForwardedRef<any>;
            newName: string;
            onChange: React.ChangeEventHandler<any>;
        }> | undefined) => {
            name: string;
            ref: any;
            onChange: any;
        };
        isValid: () => Promise<boolean>;
        validate: () => Promise<boolean>;
        getError: () => Record<NF, string>[NF];
        getValue: () => import("./types").ConvertToFormPrimitiveValue<F[N][typeof FIELD_SCHEMA_SYMBOL]["defaultValue"]>;
        setError: (error: string) => void;
        setValue: <V extends import("./types").ConvertToFormPrimitiveValue<F[N][typeof FIELD_SCHEMA_SYMBOL]["defaultValue"]>>(value: V | ((prevValue: V) => V)) => void;
    };
    bind: (name: NF, options?: Partial<{
        ref: React.ForwardedRef<any>;
        newName: string;
        onChange: React.ChangeEventHandler<any>;
    }> | undefined) => {
        name: string;
        ref: any;
        onChange: any;
    };
    isValid: (target?: NG | undefined) => Promise<boolean>;
    getError: (name: NF) => Record<NF, string>[NF];
    getErrors: () => Record<NF, string>;
    setError: (name: NF, error: string) => void;
    setErrors: (errors: Partial<Record<NF, string>>) => void;
    getValue: <N_1 extends NF>(name: N_1) => import("./types").ConvertToFormPrimitiveValue<F[N_1][typeof FIELD_SCHEMA_SYMBOL]["defaultValue"]>;
    getValues: () => { [K in NF]: import("./types").ConvertToFormPrimitiveValue<F[K][typeof FIELD_SCHEMA_SYMBOL]["defaultValue"]>; };
    setValue: <N_2 extends NF, V_1 extends import("./types").ConvertToFormPrimitiveValue<F[N_2][typeof FIELD_SCHEMA_SYMBOL]["defaultValue"]>>(name: N_2, value: V_1 | ((prevValue: V_1) => V_1)) => void;
    setValues: (values: Partial<{ [K_1 in NF]: import("./types").ConvertToFormPrimitiveValue<F[K_1][typeof FIELD_SCHEMA_SYMBOL]["defaultValue"]>; }>) => void;
    validate: (target?: NG | undefined) => Promise<boolean>;
};
export declare type UseFormixReturnType<T extends FormSchemaBase, U extends FormSchema<T>[FormSchemaSymbol] = FormSchema<T>[FormSchemaSymbol], F extends U["fields"] = U["fields"], G extends U["groups"] = U["groups"], NF extends keyof F = keyof F, NG extends keyof G = keyof G> = {
    bind: (name: NF, options?: Partial<{
        ref: React.ForwardedRef<any>;
        newName: string;
        onChange: React.ChangeEventHandler<any>;
    }>) => {
        name: NF | string;
        ref: React.RefObject<any>;
        onChange: React.ChangeEventHandler<any>;
    };
    isValid: (target?: NG) => Promise<boolean>;
    validate: (target?: NG) => Promise<boolean>;
    getError: (name: NF) => string;
    getErrors: () => Record<NF, string>;
    setError: (name: NF, error: string) => void;
    setErrors: (errors: Partial<Record<NF, string>>) => void;
    getValue: <N extends NF>(name: N) => ConvertFieldToFormPrimitiveValue<F[N]>;
    getValues: () => {
        [K in NF]: ConvertFieldToFormPrimitiveValue<F[K]>;
    };
    setValue: <N extends NF, V extends ConvertFieldToFormPrimitiveValue<F[N]>>(name: N, value: ((prevValue: V) => V) | V) => void;
    setValues: (values: Partial<{
        [K in NF]: ConvertFieldToFormPrimitiveValue<F[K]>;
    }>) => void;
    $: <N extends NF>(name: N) => {
        [K in keyof Omit<UseFormixReturnType<T, U, F, G, N, NG>, "$" | "getValues" | "getErrors" | "setErrors" | "setValues">]: (...params: ArrayShift<Parameters<UseFormixReturnType<T, U, F, G, N, NG>[K]>>) => ReturnType<UseFormixReturnType<T, U, F, G, N, NG>[K]>;
    };
};
export declare function useField<T extends string, V extends FormValuePrimitive>(name: T, schemaOrDefaultValue: V | FieldSchemaBase<V>): ReturnType<UseFormixReturnType<{
    [key in T]: V;
}>["$"]>;
